#include "test_examples.h"
#include "example_01.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void f_01(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* Comm)
{
	f[0] = Z(0,0);
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		userProvidedJac->yIndependent = DDEM_TRUE;
		ZJAC(0,0,0) = 1.0;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
}
void delayArguments_01(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* Comm)
{
  alpha[0] = y[0];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		YJAC(0,0) = 1.0;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
}
void y0s_01(int l, double* p,
                       int m, double* y0,
                       ddemUserProvidedJac* userProvidedJac,
											 void* Comm)
{
	y0[0] = p[0];
	if(userProvidedJac->needed)
	{
		PJAC(0,0) = 1.0;
	}
}
void get_problemDescriber_01(ddemProblemDescriber* pD)
{
	pD->nVariables = 1; 
	pD->nParameters = 1;
	pD->nHistorySegments = 1;

	pD->fFuncs = f_01;

	pD->historySegmentsType = DDEM_SPECIFIED_BY_CONSTANT; //{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->historySegmentsConstant = new double[pD->nVariables];
	pD->historySegmentsConstant[0] = 0.5;

  pD->historyStartsType = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->historyStartsConstant = new double [pD->nHistorySegments];
	pD->historyStartsConstant[0] = -10001.01; 

	

	pD->t0Type = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->t0Constant = 2.0;

	pD->t0DiscDegree = 0;

	pD->y0sType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_HISTORY, DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->y0sFunc = y0s_01 ;

	pD->nu = 1;
	pD->omega = 0;
	pD->delayArgumentsType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->delayArgumentsFunc = delayArguments_01;
	pD->stateDependent = DDEM_TRUE;//{DDEM_FALSE, DDEM_TRUE}
}
void get_simulationDescriber_01(ddemProblemDescriber* pD,
										ddemSimulationDescriber* sD)
{
	sD->parameters = new double[pD->nParameters];
	sD->parameters[0] = 1.0;

	sD->tEnd = 5.5;

	double TOL = 1e-6;

	sD->relTolerance = TOL;
	sD->absTolerance = new double[pD->nVariables];
	sD->absTolerance[0] = TOL;
}
