#include "test_examples.h"
#include "example_02.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_02(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* Comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
  double temp = y[0] * y[0] /( y[0] * y[0] + 1.0);
	f[0] = y[0] * (1.0 - Z(0,0) - p[1] * Z(0,1)) - y[1] * temp;
  f[1] = y[1] * (temp - p[2]);
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		// TJAC(0) = ;

		//userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		double par_temp_par_y0 = 2.0 * y[0] / (( y[0] * y[0] + 1.0) * ( y[0] * y[0] + 1.0));
		YJAC(0,0) = (1.0 - Z(0,0) - p[1] * Z(0,1)) - y[1] * par_temp_par_y0;
		YJAC(0,1) = - temp;
		YJAC(1,0) = y[1] * par_temp_par_y0;
		YJAC(1,1) = temp - p[2];
		// YJAC(0,0) = ;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		ZJAC(0,0,0) = - y[0];
		ZJAC(0,0,1) = - y[0] * p[1];
		ZJAC(0,1,0) = 0.0;
		ZJAC(0,1,1) = 0.0;

		ZJAC(1,0,0) = 0.0;
		ZJAC(1,0,1) = 0.0;
		ZJAC(1,1,0) = 0.0;
		ZJAC(1,1,1) = 0.0;

		//userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		PJAC(0,0) = 0.0;
		PJAC(0,1) = - y[0] * Z(0,1);
		PJAC(0,2) = 0.0;
		PJAC(0,3) = 0.0; PJAC(0,4) = 0.0; PJAC(0,5) = 0.0; PJAC(0,6) = 0.0;

		PJAC(1,0) = 0.0;
		PJAC(1,1) = 0.0;
		PJAC(1,2) = - y[1];
		PJAC(1,3) = 0.0; PJAC(1,4) = 0.0; PJAC(1,5) = 0.0; PJAC(1,6) = 0.0;
	}
}
/*---------------------------------------------*/
void historySegments_02(int historySegmentIndex,
											 double t,
                       int l, double* p,
                       int m, double* h,
                       ddemUserProvidedJac* userProvidedJac,
											 void* Comm)
{
	// hIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set h[hIndices]
  h[0] = p[3] + p[4] * t;
	h[1] = p[5] + p[6] * t;
	if(userProvidedJac->needed)
	{
		TJAC(0) = p[4];
		TJAC(1) = p[6];

		//userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(hIndices, pIndices)
		PJAC(0,0) = 0.0; PJAC(0,1) = 0.0; PJAC(0,2) = 0.0;
		PJAC(0,3) = 1.0;
		PJAC(0,4) = t;
		PJAC(0,5) = 0.0; PJAC(0,6) = 0.0;

		PJAC(1,0) = 0.0; PJAC(1,1) = 0.0; PJAC(1,2) = 0.0;
		PJAC(1,3) = 0.0; PJAC(1,4) = 0.0;
		PJAC(1,5) = 1.0;
		PJAC(1,6) = t;

		if(userProvidedJac->needed2nd)
		{
			userProvidedJac->ttIndependent = DDEM_TRUE;
			// or set TTJAC(hIndices)
			// TTJAC(0) = ;
			
			userProvidedJac->tpIndependent = DDEM_TRUE;
			// or set TPJAC(hIndices, pIndices)
			// TPJAC(0,0) = ;
			TPJAC(0,0) = 0.0; TPJAC(0,1) = 0.0; TPJAC(0,2) = 0.0;
			TPJAC(0,3) = 0.0;
			TPJAC(0,4) = 1.0;
			TPJAC(0,5) = 0.0; TPJAC(0,6) = 0.0;

			TPJAC(1,0) = 0.0; TPJAC(1,1) = 0.0; TPJAC(1,2) = 0.0;
			TPJAC(1,3) = 0.0; TPJAC(1,4) = 0.0;
			TPJAC(1,5) = 0.0;
			TPJAC(1,6) = 1.0;
		}
	}
}
/*---------------------------------------------*/
void delayArguments_02(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* Comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = t - p[0];
  alpha[1] = t - p[0];
	if(userProvidedJac->needed)
	{
		//userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;
		TJAC(0) = 1.0;
		TJAC(1) = 1.0;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		// YJAC(0,0) = ;

		//userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
		PJAC(0,0) = - 1.0;
		PJAC(0,1) = 0.0; PJAC(0,2) = 0.0; PJAC(0,3) = 0.0;
		PJAC(0,4) = 0.0; PJAC(0,5) = 0.0; PJAC(0,6) = 0.0;
		PJAC(1,0) = - 1.0;
		PJAC(1,1) = 0.0; PJAC(1,2) = 0.0; PJAC(1,3) = 0.0;
		PJAC(1,4) = 0.0; PJAC(1,5) = 0.0; PJAC(1,6) = 0.0;
	}
}
void get_problemDescriber_02(ddemProblemDescriber* pD)
{
	pD->nVariables = 2 ; 
	pD->nParameters = 7;
	pD->nHistorySegments = 1;

	pD->fFuncs = f_02;

	pD->historySegmentsType = DDEM_SPECIFIED_BY_FUNC; //{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->historySegmentsFunc = historySegments_02;

  pD->historyStartsType = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}


	pD->t0Type = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->t0Constant = 0.0;

	pD->t0DiscDegree = 1;

	pD->y0sType = DDEM_SPECIFIED_BY_HISTORY;//{DDEM_SPECIFIED_BY_HISTORY, DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}

	pD->nu = 1;
	pD->omega = 1;
	pD->delayArgumentsType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}

	pD->delayArgumentsFunc = delayArguments_02;
	pD->stateDependent = DDEM_TRUE;//{DDEM_FALSE, DDEM_TRUE}
}
void get_simulationDescriber_02(ddemProblemDescriber* pD,
										ddemSimulationDescriber* sD)
{
	sD->parameters = new double[pD->nParameters];
	sD->parameters[0] = 21.0 / 50.0; // tau
	sD->parameters[1] = 29.0 / 10.0; // rho
	sD->parameters[2] = 1.0 / 10.0; // alpha
	sD->parameters[3] = 33.0 / 100.0; // phi_1 constant
	sD->parameters[4] = - 1.0 / 10.0 ; // phi_1 slope
	sD->parameters[5] = 111.0 / 50.0; // phi_2 constant
	sD->parameters[6] = 1.0 / 10.0; // phi_2 slope

	sD->tEnd = 30.0;

	double TOL = 1e-6;

	sD->relTolerance = TOL;//6
	sD->absTolerance = new double[pD->nVariables];
	sD->absTolerance[0] = TOL;//6
	sD->absTolerance[1] = TOL;//6
}

