#include <math.h>

#include "test_examples.h"
#include "example_03.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_03(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* Comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
  f[0] = y[0] * Z(0,0) / t;
	if(userProvidedJac->needed)
	{
		//userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		TJAC(0) = - y[0] * Z(0,0) / (t*t);

		//userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		YJAC(0,0) =  Z(0,0) / t;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		ZJAC(0,0,0) = y[0] / t;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
void delayArguments_03(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* Comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = log(y[0]);
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;

		//userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		YJAC(0,0) = 1/y[0];

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
void t0_03(int l, double* p,
                       double& tStart,
                       ddemUserProvidedJac* userProvidedJac,
											 void* Comm)
{
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set tStart
	tStart = p[0];
	if(userProvidedJac->needed)
	{
		//userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(0, pIndices)
		PJAC(0,0) = 1.0;
	}
}
void get_problemDescriber_03(ddemProblemDescriber* pD)
{
	pD->nVariables = 1; 
	pD->nParameters = 1;
	pD->nHistorySegments = 1;

	pD->fFuncs = f_03;

	pD->historySegmentsType = DDEM_SPECIFIED_BY_CONSTANT; //{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->historySegmentsConstant = new double[pD->nVariables];
	pD->historySegmentsConstant[0] = 1.0;	

	pD->t0Type = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->t0Func = t0_03;

	pD->t0DiscDegree = 1;

	pD->y0sType = DDEM_SPECIFIED_BY_HISTORY;//{DDEM_SPECIFIED_BY_HISTORY, DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}

	pD->nu = 1;
	pD->omega = 0;
	pD->delayArgumentsType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}

	pD->delayArgumentsFunc = delayArguments_03;
	pD->stateDependent = DDEM_TRUE;//{DDEM_FALSE, DDEM_TRUE}
}
void get_simulationDescriber_03(ddemProblemDescriber* pD,
										ddemSimulationDescriber* sD)
{
	sD->parameters = new double[pD->nParameters];
	sD->parameters[0] = 1.0;
	
	sD->tEnd = 10.0;

	double TOL = 1e-6; 

	sD->relTolerance = TOL;
	sD->absTolerance = new double[pD->nVariables];
	sD->absTolerance[0] = TOL;
}

