#include <math.h>

#include "test_examples.h"
#include "example_04.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_04(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* Comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
  f[0] = Z(0,0);
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		// YJAC(0,0) = ;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		// ZJAC(0,0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void historySegments_04(int historySegmentIndex,
											 double t,
                       int l, double* p,
                       int m, double* h,
                       ddemUserProvidedJac* userProvidedJac,
											 void* Comm)
{
	// hIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set h[hIndices]
  h[0] = t;
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(hIndices)
		// TJAC(0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(hIndices, pIndices)
		// PJAC(0,0) = ;

		if(userProvidedJac->needed2nd)
		{
			userProvidedJac->ttIndependent = DDEM_TRUE;
			// or set TTJAC(hIndices)
			// TTJAC(0) = ;
			
			userProvidedJac->tpIndependent = DDEM_TRUE;
			// or set TPJAC(hIndices, pIndices)
			// TPJAC(0,0) = ;
		}
	}
}
/*---------------------------------------------*/
void delayArguments_04(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* Comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = t - pow(t,-10.0);
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		// YJAC(0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void get_problemDescriber_04(ddemProblemDescriber* pD)
{
	pD->nVariables = 1; 
	pD->nParameters = 0;
	pD->nHistorySegments = 1;

	pD->fFuncs = f_04;

	pD->historySegmentsType = DDEM_SPECIFIED_BY_FUNC; //{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->historySegmentsFunc = historySegments_04;


	pD->t0Type = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->t0Constant = 1.0;

	pD->t0DiscDegree = 1;

	pD->y0sType = DDEM_SPECIFIED_BY_HISTORY;//{DDEM_SPECIFIED_BY_HISTORY, DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}

	pD->nu = 1;
	pD->omega = 0;
	pD->delayArgumentsType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->delayArgumentsFunc = delayArguments_04;

	pD->stateDependent = DDEM_TRUE;//{DDEM_FALSE, DDEM_TRUE}
}
void get_simulationDescriber_04(ddemProblemDescriber* pD,
										ddemSimulationDescriber* sD)
{

	sD->tEnd = 10.0;

	double TOL = 1e-6;

	sD->relTolerance = TOL;
	sD->absTolerance = new double[pD->nVariables];
	sD->absTolerance[0] = TOL;

	sD->vanishingConst = 1e-2;
}

