#include <math.h>

#include "test_examples.h"
#include "example_05.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_05(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* Comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
  f[0] = Z(0,0) + (3 + p[0]) * pow(t, 2 + p[0]) - 
					pow(t, (3 + p[0]) * (3 + p[0]));
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		// YJAC(0,0) = ;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		// ZJAC(0,0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void delayArguments_05(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* Comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = y[0];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		// YJAC(0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
void get_problemDescriber_05(ddemProblemDescriber* pD)
{
	pD->nVariables = 1; 
	pD->nParameters = 1;
	pD->nHistorySegments = 0;

	pD->fFuncs = f_05;



	pD->t0Type = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->t0Constant = 0.0;

	pD->t0DiscDegree = 0;

	pD->y0sType = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_HISTORY, DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->y0sConstant = new double[pD->nVariables];
	pD->y0sConstant[0] = 0.0;

	pD->nu = 1;
	pD->omega = 0;
	pD->delayArgumentsType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->delayArgumentsFunc = delayArguments_05;

	pD->stateDependent = DDEM_TRUE;//{DDEM_FALSE, DDEM_TRUE}
}
void get_simulationDescriber_05(ddemProblemDescriber* pD,
										ddemSimulationDescriber* sD)
{
	sD->parameters = new double[pD->nParameters];
	sD->parameters[0] = 0.0;/*alpha*/

	sD->tEnd = 1;

	double TOL = 1e-6;

	sD->relTolerance = TOL;
	sD->absTolerance = new double[pD->nVariables];
	sD->absTolerance[0] = TOL;

	sD->vanishingConst = 1e-2;
}
