#include <math.h>

#include "test_examples.h"
#include "example_06.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_06(int state, double t, int m, double* y,
										  int nu, int omega_delay, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* Comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
  
     double A = p[0];// A=RPAR(1)
     double d = p[1];// d= RPAR(2)
     double lambda = p[2];// lambda = RPAR(3)
     double gamma = p[3];// gamma = RPAR(4)
     double epsilon = p[4];// epsilon = RPAR(5)
     double tau = p[5];// tau = RPAR(6)
     double omega = p[6];// omega = RPAR(7)

     double yN = y[0] + y[1] + y[2] + y[3];// yN = Y(1) + Y(2) + Y(3) +Y(4)
     double yNomega = Z(0,1) + Z(1,1) + Z(2,1) + Z(3,1);// yNomega = Y1L2 + Y2L2 + Y3L2+ Y4L2
     // 
     f[0] = A-d*y[0]-lambda*y[0]*y[2]/yN + gamma*Z(2,0)*exp(-d*tau);
     // F(1) = A-d*Y(1)-lambda*Y(1)*Y(3)/yN + gamma*Y3L1*EXP(-d*tau)
     f[1] = lambda*y[0]*y[2]/yN - 
						lambda *Z(0,1)*Z(2,1)/yNomega*exp(-d*omega)-d*y[1];
     // F(2) = lambda*Y(1)*Y(3)/yN - 
     //&    lambda *Y1L2*Y3L2/yNomega*EXP(-d*omega)-d*Y(2)
     f[2] = lambda *Z(0,1)*Z(2,1)/yNomega*exp(-d*omega) -
			      (gamma+epsilon+d)*y[2];
     // F(3) = lambda *Y1L2*Y3L2/yNomega*EXP(-d*omega) -
     //&      (gamma+epsilon+d)*Y(3)
     f[3] = gamma*y[2] - gamma*Z(2,0)*exp(-d*tau)-d*y[3];
     // F(4) = gamma*Y(3) - gamma*Y3L1*EXP(-d*tau)-d*Y(4)
	
	
	//f[0] = 0.0;
 // f[1] = 0.0;
 // f[2] = 0.0;
 // f[3] = 0.0;
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		// YJAC(0,0) = ;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		// ZJAC(0,0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void delayArguments_06(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* Comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = t - p[5];
  alpha[1] = t - p[6];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		// YJAC(0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void get_problemDescriber_06(ddemProblemDescriber* pD)
{
	pD->nVariables = 4; 
	pD->nParameters = 7;
	pD->nHistorySegments = 1;

	pD->fFuncs = f_06;

	pD->historySegmentsType = DDEM_SPECIFIED_BY_CONSTANT; //{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->historySegmentsConstant = new double[pD->nVariables];
	pD->historySegmentsConstant[0] = 15.0;
	pD->historySegmentsConstant[1] = 0.0;
	pD->historySegmentsConstant[2] = 2.0;
	pD->historySegmentsConstant[3] = 3.0;


	pD->t0Type = DDEM_SPECIFIED_BY_CONSTANT;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->t0Constant = 0.0;

	pD->t0DiscDegree = 1;

	pD->y0sType = DDEM_SPECIFIED_BY_HISTORY;//{DDEM_SPECIFIED_BY_HISTORY, DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}

	pD->nu = 2;
	pD->omega = 0;
	pD->delayArgumentsType = DDEM_SPECIFIED_BY_FUNC;//{DDEM_SPECIFIED_BY_CONSTANT, DDEM_SPECIFIED_BY_FUNC}
	pD->delayArgumentsFunc = delayArguments_06;

	pD->stateDependent = DDEM_FALSE;//{DDEM_FALSE, DDEM_TRUE}
}
void get_simulationDescriber_06(ddemProblemDescriber* pD,
										ddemSimulationDescriber* sD)
{
	sD->parameters = new double[pD->nParameters];
  sD->parameters[0]=0.33; // A
  sD->parameters[1]=0.006; // d 
  sD->parameters[2]= 0.308; // lambda
  sD->parameters[3]= 0.04; // gamma
  sD->parameters[4]= 0.06; // epsilon
  sD->parameters[5]=  42; // tau
  sD->parameters[6]=  0.15; // omega



	sD->tEnd = 350.0;

	double TOL = 1e-6;

	sD->relTolerance = TOL;
	sD->absTolerance = new double[pD->nVariables];
	sD->absTolerance[0] = TOL;
	sD->absTolerance[1] = TOL;
	sD->absTolerance[2] = TOL;
	sD->absTolerance[3] = TOL;

	sD->vanishingConst = 0.5;
}

