#ifndef __DDEM_IVP2DDE
#define __DDEM_IVP2DDE
/*-------------------*/
typedef int (*ddemIVPfcn) (int*n, double* x, double* y, double* yprime,
													 void* ivp2ddeCommVoid);
#define DDEM_ACCEPT 1
#define DDEM_REJECT 2
#define DDEM_AT_END 3

#define DDEM_INTERP 1
#define DDEM_DERIV_INTERP  2
#define DDEM_NONE 3

/*This is an abstract class*/
class ddemIVP2DDE{
	public:
		virtual int getNInterploatorCoefficens()=0;
		virtual int getRequiredContinuity()=0;
		virtual void prepare(int nVariables, double relTolerance, double* absTolerance)=0;
		virtual int tryStep(double& t, double tEnd,
																	double* y,
																	ddemIVPfcn IVPfcn, void* ivp2ddeCommVoid)=0;
		virtual void storeStep(double& t, double* y, double** interpolant,
																		double& stepSize)=0;
		virtual void restart()=0;
		virtual int interpolate(int nVariables,
														double tLeftMeshPoint,
																		 double* yLeftMeshPoint,
																		 double t, double* y, double stepSize,
																		 double** interpolant,
																		 int interpSelect)=0;
};
#endif
