/* DOUBLE CHECKED = YES*/
#include <iostream>
using namespace std;

#include "ddem_min_root.h"
extern "C" {
#include "ddem_roots.h"
};
#include "ddem_trace.h"
#include "ddem_error_codes.h"
#include "ddem_basic_defins.h"
int ddemMinRoot(double t0, double t1,
								int ng,
								double* g0, double* g1,
								ddemRootfcn g,
								double errTol,
								double& t,
								double* gt,
								int* active,
								void* comm,
								int& nfcnCall)
{
	int retCode = DDEM_SUCCESS;
	/*---------------------------*/
	nfcnCall = 0;
	int jflag = 0;
	struct ddem_roots_static_data* lsr001_1;
	lsr001_1 = new struct ddem_roots_static_data;
	int shouldReturn = DDEM_FALSE;
	while((jflag < 2) && (shouldReturn == DDEM_FALSE)){
		ddem_roots_(&ng/* int *ng */,
					&errTol/* double *hmin */,
					&jflag/* int *jflag */, 
					&t0/* double *x0 */,
					&t1/* double *x1 */,
					g0/* double *g0 */,
					g1/* double *g1 */, 
					gt/* double *gx */,
					&t/* double *x */,
					active/* int *jroot */,
					lsr001_1);
		switch(jflag){
			case 1:
					g(t, gt, comm);
					/*cout << "t = " << t << endl;*/
					nfcnCall += 1;
				break;
			case 2:
				break;
			case 3:
				break;
			case 4:
				if(DDEM_TRACE_MIN_ROOT){
					cout << "no roots (of odd multiplicity) were "
							 << "found in (t0,t1) (no sign changes)." << endl;
					cout << "jflag = " << jflag << endl;
				}
				shouldReturn = DDEM_TRUE;
				retCode = DDEM_ERR_MINROOT_NO_ROOTS_WERE_FOUND;/*-jflag*/;
				break;
			default:
				if(DDEM_TRACE_MIN_ROOT){
					cout <<"Error in ddemMinRoot" << endl;
					cout <<"unexpected jflag value" << endl;
					cout <<"jflag = " << jflag << endl;
				}
				shouldReturn = DDEM_TRUE;
				retCode = DDEM_ERR_UNEXPECTED;/*-jflag;*/
		};
	}
	/*cout <<"jflag = " << jflag << endl;*/
/*---------------------------*/
	delete lsr001_1;
	return retCode;
}
