/* DOUBLE CHECKED = YES*/
#include <iostream>
using namespace std;
#include "ddem_problem.h"
#include "ddem_error_codes.h"
#include "ddem_trace.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
ddemUserProvidedJac::ddemUserProvidedJac()
{
	tJac = NULL;
	pJac = NULL;
	yJac = NULL;
	zJac = NULL;

	ttJac = NULL;
	tpJac = NULL;
}
/************************************************************/
ddemUserProvidedJac::~ddemUserProvidedJac()
{
	if(tJac != NULL){delete tJac;	tJac = NULL;}
	if(pJac != NULL){delete pJac;	pJac = NULL;}
	if(yJac != NULL){delete yJac;	yJac = NULL;}
	if(zJac != NULL){delete zJac;	zJac = NULL;}

	if(ttJac != NULL){delete ttJac;	ttJac = NULL;}
	if(tpJac != NULL){delete tpJac;	tpJac = NULL;}
}
/************************************************************/
void ddemUserProvidedJac::reset()
{
		tIndependent = DDEM_FALSE;
		pIndependent = DDEM_FALSE;
		yIndependent = DDEM_FALSE;
		zIndependent = DDEM_FALSE;

		ttIndependent = DDEM_FALSE;
		tpIndependent = DDEM_FALSE;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
int ddemAutomata::getCurrentState()
{
	return currentState_;
}
/************************************************************/
int ddemAutomata::getNEvents()
{
	return nEvents_;
}
/************************************************************/
int ddemAutomata::create(int nEvents)
{
	if(created_ == DDEM_FALSE){
		nEvents_ = nEvents;
		terminal_ = new int[nEvents];

		events_ = NULL;
		changeFunc_= NULL;
		
		currentState_ =  1;/*default starting state*/

		created_ = DDEM_TRUE;
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
ddemAutomata::ddemAutomata()
{
	created_ = DDEM_FALSE;
}
/************************************************************/
ddemAutomata::~ddemAutomata()
{
	if(terminal_!=NULL){
		delete terminal_;
		terminal_ = NULL;
	}
}
/************************************************************/
int ddemAutomata::setF(ddemF fFuncs)
{
	fFuncs_ = fFuncs;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemAutomata::setStartState(int startState)
{
	currentState_ = startState;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemAutomata::setEvents(ddemEvents events, int* terminal)
{
	if(created_ == DDEM_TRUE){
		events_ = events;
		if(terminal != NULL)
			for(int i=0; i < nEvents_; i++)
				terminal_[i] = terminal[i];
		else
			for(int i=0; i < nEvents_; i++)
				terminal_[i] = DDEM_FALSE;
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemAutomata::setChangeFunc(ddemChangeFunc changeFunc)
{	
	changeFunc_ = changeFunc;
	return DDEM_SUCCESS;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
int ddemHistory::create(int nHistorySegments)
{
	if(created_ == DDEM_FALSE){
		if(nHistorySegments > 0){
			nHistorySegments_ = nHistorySegments;
			historySegmentsConstant_ = NULL;
			historySegmentsFunc_ = NULL;
			historyStartsFunc_ = NULL;
			historyStartsConstant_ = NULL;
			historyStartsType_ = DDEM_NOT_SPECIFIED;
			historySegmentsType_ = DDEM_NOT_SPECIFIED;

			historyStartsDiscDegreesConstant_ = NULL;

			created_ = DDEM_TRUE;
			return DDEM_SUCCESS;
		}else
			return DDEM_FAILURE;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
ddemHistory::ddemHistory()
{
	historySegmentsConstant_ = NULL;
	historyStartsConstant_ = NULL;
	historyStartsDiscDegreesConstant_ = NULL;
	created_ = DDEM_FALSE;
}
/************************************************************/
ddemHistory::~ddemHistory()
{
	if(created_ == DDEM_TRUE){
		if(historySegmentsConstant_ != NULL){
			delete historySegmentsConstant_;
			historySegmentsConstant_= NULL;
		}
		if(historyStartsConstant_ != NULL){
			delete historyStartsConstant_;
			historyStartsConstant_ = NULL;
		}
		if(historyStartsDiscDegreesConstant_ != NULL){
			delete historyStartsDiscDegreesConstant_;
			historyStartsDiscDegreesConstant_ = NULL;
		}
	}
}
/************************************************************/
int  ddemHistory::setHistorySegments(double* historySegmentsConstant)
{
	if(created_ == DDEM_TRUE){
		if(nHistorySegments_ == 1){
			int nVariables = getNVariables();
			historySegmentsType_ = DDEM_SPECIFIED_BY_CONSTANT;
			if (historySegmentsConstant_ == NULL)
				historySegmentsConstant_ = new double[nVariables];
			for (int i = 0; i < nVariables; i++)
				historySegmentsConstant_[i] = historySegmentsConstant[i];
			return DDEM_SUCCESS;
		}else
			return DDEM_FAILURE;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemHistory::setHistorySegments(ddemHistorySegments historySegmentsFunc)
{
	historySegmentsFunc_ = historySegmentsFunc;
	historySegmentsType_ = DDEM_SPECIFIED_BY_FUNC;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemHistory::setHistoryStarts(double* historyStartsConstant)
{
	historyStartsType_ = DDEM_SPECIFIED_BY_CONSTANT;

	if(created_ == DDEM_TRUE){
		if(historyStartsConstant_ == NULL)
			historyStartsConstant_ = new double[nHistorySegments_ - 1]; 
		for(int j=0; j < nHistorySegments_ - 1; j++)
			historyStartsConstant_[j] = historyStartsConstant[j];
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemHistory::setHistoryStarts(ddemHisoryStarts historyStartsFunc)
{
	historyStartsFunc_ = historyStartsFunc;
	historyStartsType_ = DDEM_SPECIFIED_BY_FUNC;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemHistory::setHistoryStartsDiscDegrees(int* historyStartsDiscDegreesConstant)
{
	if(created_ == DDEM_TRUE){
		if(historyStartsDiscDegreesConstant_ == NULL)
			historyStartsDiscDegreesConstant_ = new int[nHistorySegments_ - 1]; 
		for(int j=0; j < nHistorySegments_ - 1; j++)
			historyStartsDiscDegreesConstant_[j] = historyStartsDiscDegreesConstant[j];
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
ddemStartingConditions::ddemStartingConditions()
{
	y0sConstant_ = NULL;
	created_ = DDEM_FALSE;
}
/************************************************************/
int ddemStartingConditions::create()
{
	if(created_ == DDEM_FALSE){
		t0Type_ = DDEM_NOT_SPECIFIED;
		y0sType_ = DDEM_NOT_SPECIFIED;
		y0sConstant_ = NULL;


		created_ = DDEM_TRUE;
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
ddemStartingConditions::~ddemStartingConditions()
{
	if(y0sConstant_ != NULL){
		delete y0sConstant_;
		y0sConstant_ = NULL;
	}
}
/************************************************************/
int ddemStartingConditions::setT0(double t0Constant)
{
  t0Type_ = DDEM_SPECIFIED_BY_CONSTANT;
  t0Constant_ = t0Constant;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemStartingConditions::setT0(ddemT0 t0Func)
{
  t0Type_ = DDEM_SPECIFIED_BY_FUNC;
  t0Func_ = t0Func;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemStartingConditions::setT0DiscDegree(int t0DiscDegreeConstant)
{
	t0DiscDegreeConstant_ = t0DiscDegreeConstant;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemStartingConditions::setY0(double* y0Constant)
{
	if(created_ == DDEM_TRUE){
		int nVariables = getNVariables();
		y0sType_ = DDEM_SPECIFIED_BY_CONSTANT;
		if (y0sConstant_ == NULL)
			y0sConstant_ = new double[nVariables];
		for (int i = 0; i < nVariables; i++)
			y0sConstant_[i] = y0Constant[i];
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemStartingConditions::setY0(ddemY0 y0Func)
{
  y0sType_ = DDEM_SPECIFIED_BY_FUNC;
  y0sFunc_ = y0Func;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemStartingConditions::setY0()
{
  y0sType_ = DDEM_SPECIFIED_BY_HISTORY;
	return DDEM_SUCCESS;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
int ddemProblem::getNVariables()
{
	return nVariables_;
}
/************************************************************/
int ddemProblem::getNParameters()
{
	return nParameters_;
}
/************************************************************/
int ddemProblem::getNHistorySegments()
{
	return nHistorySegments_;
}
/************************************************************/
int ddemProblem::getNu()
{
	return nu_;
}
/************************************************************/
int ddemProblem::getOmega()
{
	return omega_;
}
/************************************************************/
ddemProblem::ddemProblem()
{
	delayArgumentsConstant_ = NULL;
	created_ = DDEM_FALSE;
	infinityBound_ = 1e+20;
}
/************************************************************/
int ddemProblem::create(int nVariables, int nParameters,
						int nEvents,
						int nHistorySegments)
{
	if(created_ == DDEM_FALSE){
		ddemAutomata::create(nEvents);
		if(nHistorySegments > 0)
			ddemHistory::create(nHistorySegments);
		ddemStartingConditions::create();

		nParameters_ = nParameters;
		nVariables_ = nVariables;
		delayArgumentsType_ = DDEM_NOT_SPECIFIED;
		delayArgumentsConstant_ = NULL;
		createUserProvidedJacs_();

		created_ = DDEM_TRUE;
		return DDEM_SUCCESS;
	}else
		return DDEM_FAILURE;
}
/************************************************************/
ddemProblem::~ddemProblem()
{
	if(delayArgumentsConstant_ != NULL){
		delete delayArgumentsConstant_;
		delayArgumentsConstant_ = NULL;
	}
	destroyUserProvidedJacs_();
}
/************************************************************/
int ddemProblem::setDelayArguments(int nu, int omega, double* delayArgumentsConstant)
{
	if(created_ == DDEM_FALSE)
		return DDEM_FAILURE;

	nu_ = nu;
  omega_ = omega;
  if (delayArgumentsConstant_ != NULL)
    delete delayArgumentsConstant_;
  delayArgumentsConstant_ = new double[nu_ + omega_];
	for(int i=0; i< nu_ + omega_; i++)
		delayArgumentsConstant_[i] = delayArgumentsConstant[i];
  delayArgumentsType_ = DDEM_SPECIFIED_BY_CONSTANT;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::setDelayArguments(int nu, int omega,
                       ddemDelayArguments delayArgumentsFunc,
											 int stateDependent)
{
	if(created_ == DDEM_FALSE)
		return DDEM_FAILURE;

	nu_ = nu;
  omega_ = omega;
  delayArgumentsFunc_ = delayArgumentsFunc;
  delayArgumentsType_ = DDEM_SPECIFIED_BY_FUNC;
	stateDependent_ = stateDependent;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::checkIntegrity(void)
{
	if(created_ == DDEM_FALSE)
		return DDEM_FAILURE;

	if(t0Type_ == DDEM_NOT_SPECIFIED)
		return -11;
	else if(y0sType_ == DDEM_NOT_SPECIFIED)
		return -12;
	else if( (nHistorySegments_ > 1) && (historyStartsType_ == DDEM_NOT_SPECIFIED))
			return -13;
	else if((nHistorySegments_ > 0) && (historySegmentsType_ == DDEM_NOT_SPECIFIED))
			return -14;
	else if(delayArgumentsType_ == DDEM_NOT_SPECIFIED)
		return -15;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::evalF(double t, double* y,
								 double* z,
								 double* p,
								 double* f,
								 void* Comm)
{
	userProvidedJac4F_->reset();
	userProvidedJac4F_->needed = DDEM_FALSE;
	userProvidedJac4F_->needed2nd = DDEM_FALSE;
	return evalFBase(t, y,
						z,
						p,
						f,
            userProvidedJac4F_,
						Comm);
}
/************************************************************/
int ddemProblem::evalFBase(double t, double* y,
								 double* z,
								 double* p,
								 double* f,
                 ddemUserProvidedJac* userProvidedJac,
								 void* Comm)
{
  fFuncs_(currentState_, t, nVariables_, y,
								  nu_, omega_, z,
									nParameters_, p,
									f,
                  userProvidedJac,
									Comm);
	if(userProvidedJac->needed){
		if(userProvidedJac->tIndependent)
			for(int i=0; i < nVariables_; i++)
				userProvidedJac->tJac[i] = 0.0;
		if(userProvidedJac->yIndependent)
			for(int i=0; i < nVariables_; i++)
				for(int j=0; j < nVariables_; j++)
					userProvidedJac->yJac[i * nVariables_ + j] = 0.0;
		if(userProvidedJac->zIndependent)
			for(int i=0; i < nVariables_; i++)
				for(int j=0; j < nu_ + omega_; j++)
					for(int k=0; k < nVariables_; k++)
					userProvidedJac->zJac[i * ((nu_ + omega_) * nVariables_) +
																j * nVariables_ + k] = 0.0;
		if(userProvidedJac->pIndependent)
			for(int i=0; i < nVariables_; i++)
				for(int j=0; j < nParameters_; j++)
					userProvidedJac->pJac[i * nParameters_ + j] = 0.0;
	}
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::evalDelayArguments(double t, double* y,
																double* p,
																double* alpha,
																void* Comm)
{
	userProvidedJac4DelayArguments_->reset();
	userProvidedJac4DelayArguments_->needed = DDEM_FALSE;
	userProvidedJac4DelayArguments_->needed2nd = DDEM_FALSE;
	return evalDelayArgumentsBase(t, y,
												p,
												alpha,
												userProvidedJac4DelayArguments_,
												Comm);
}
/************************************************************/
int ddemProblem::evalDelayArgumentsBase(double t, double* y,
																double* p,
																double* alpha,
																ddemUserProvidedJac* userProvidedJac,
																void* Comm)
{
	if(delayArgumentsType_ == DDEM_SPECIFIED_BY_CONSTANT)
	{
		for(int i=0; i < nu_ + omega_; i++)
			alpha[i] = t - delayArgumentsConstant_[i];
		if(userProvidedJac->needed)
			for(int i=0; i < nu_ + omega_; i++)
				userProvidedJac->tJac[i] = 1.0;
		userProvidedJac->yIndependent = DDEM_TRUE;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}else{
		delayArgumentsFunc_(t, nVariables_, y,
                               nParameters_, p,
                               nu_, omega_, alpha,
                               userProvidedJac,
															 Comm);
	}
	if(userProvidedJac->needed){
		if(userProvidedJac->yIndependent == DDEM_TRUE)
			for(int i=0; i < nu_ + omega_; i++)
				for(int j=0; j < nVariables_; j++)
					userProvidedJac->yJac[i * nVariables_ + j] = 0.0; 
		if(userProvidedJac->pIndependent == DDEM_TRUE)
			for(int i=0; i < nu_ + omega_; i++)
				for(int j=0; j < nParameters_; j++)
					userProvidedJac->pJac[i * nParameters_ + j] = 0.0; 
		if(userProvidedJac->tIndependent == DDEM_TRUE)
			for(int i=0; i < nu_ + omega_; i++)
					userProvidedJac->tJac[i] = 0.0; 
	}
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::evalHistoryStart(int historySegmentIndex,
															double* p,
															double& historyStart,
															void* Comm)
{
	userProvidedJac4HistoryStart_->reset();
	userProvidedJac4HistoryStart_->needed = DDEM_FALSE;
	userProvidedJac4HistoryStart_->needed2nd = DDEM_FALSE;
	return evalHistoryStartBase(historySegmentIndex,
											p,
											historyStart,
											userProvidedJac4HistoryStart_,
											Comm);
}
/************************************************************/
int ddemProblem::evalHistoryStartBase(int historySegmentIndex,
															double* p,
															double& historyStart,
															ddemUserProvidedJac* userProvidedJac,
															void* Comm)
{

  if ( historySegmentIndex >=1 &&
       historySegmentIndex <= nHistorySegments_ - 1){
			if(historyStartsType_ == DDEM_SPECIFIED_BY_FUNC)
				historyStartsFunc_(historySegmentIndex,
													nParameters_, p,
													historyStart,
													userProvidedJac,
													Comm);
			else{ 
				historyStart = historyStartsConstant_[historySegmentIndex - 1];
				userProvidedJac->pIndependent = DDEM_TRUE;
			}
		if((userProvidedJac->needed)&&
			(userProvidedJac->pIndependent == DDEM_TRUE))
			for(int i=0; i < nParameters_; i++)
				userProvidedJac->pJac[i] = 0.0;
	}else{
		if(DDEM_TRACE_PROBLEM)
		   cout << "error in ddemHistory::evalHistoryStart" <<
		           "-invalid historySegmentIndex-" << endl;
		 return DDEM_ERR_PROB_INVALID_HISTORY_SEGMENT_INDEX;
	}
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::evalHistoryStartDiscDegree(int historySegmentIndex,
																	double*p,
																	int& historyStartDiscDegree,
																	void* Comm)
{
	if ( historySegmentIndex >=1 &&
       historySegmentIndex <= nHistorySegments_ - 1){
			historyStartDiscDegree = historyStartsDiscDegreesConstant_[historySegmentIndex - 1];
	}else{
		if(DDEM_TRACE_PROBLEM)
		   cout << "error in ddemHistory::evalHistoryStartDiscDegree" <<
		           "-invalid historySegmentIndex-" << endl;
		 return DDEM_ERR_PROB_INVALID_HISTORY_SEGMENT_INDEX;
	}
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::evalDerivHistorySegment(int historySegmentIndex,
																double t,
                                double* p,
                                double* h,
															  void* Comm)
{
	userProvidedJac4HistorySegment_->reset();
	userProvidedJac4HistorySegment_->needed = DDEM_TRUE;
	userProvidedJac4HistorySegment_->needed2nd = DDEM_FALSE;
	int retCode =	evalHistorySegmentBase(historySegmentIndex,
												 t,
                         p,
                         h,
                         userProvidedJac4HistorySegment_,
												 Comm);
	if(retCode == DDEM_SUCCESS)
		for(int i=0; i < nVariables_; i++)
			h[i] = userProvidedJac4HistorySegment_->tJac[i];
	return retCode;
}
/************************************************************/
int ddemProblem::evalHistorySegment(int historySegmentIndex,
																double t,
                                double* p,
                                double* h,
															  void* Comm)
{
	userProvidedJac4HistorySegment_->reset();
	userProvidedJac4HistorySegment_->needed = DDEM_FALSE;
	userProvidedJac4HistorySegment_->needed2nd = DDEM_FALSE;
	return evalHistorySegmentBase(historySegmentIndex,
												 t,
                         p,
                         h,
                         userProvidedJac4HistorySegment_,
												 Comm);
}
/************************************************************/
int ddemProblem::evalHistorySegmentBase(int historySegmentIndex,
																double t,
                                double* p,
                                double* h,
                                ddemUserProvidedJac* userProvidedJac,
															  void* Comm)
{

  if ( historySegmentIndex >=1 &&
       historySegmentIndex <= nHistorySegments_){
		if(historySegmentsType_ == DDEM_SPECIFIED_BY_FUNC)
			historySegmentsFunc_(historySegmentIndex,
																 t,
                                 nParameters_, p,
	                               nVariables_, h,
		                             userProvidedJac,
																 Comm);
		else{
			for(int i=0; i < nVariables_; i++)
				h[i] = historySegmentsConstant_[i];
			userProvidedJac->tIndependent = DDEM_TRUE;
			userProvidedJac->pIndependent = DDEM_TRUE;
			userProvidedJac->ttIndependent = DDEM_TRUE;
			userProvidedJac->tpIndependent = DDEM_TRUE;
		}
		if(userProvidedJac->needed){
			if(userProvidedJac->tIndependent == DDEM_TRUE){
				userProvidedJac->ttIndependent = DDEM_TRUE;
				userProvidedJac->tpIndependent = DDEM_TRUE;
				for(int k=0; k < nVariables_; k++)
					userProvidedJac->tJac[k] = 0.0;
			}
			if(userProvidedJac->pIndependent == DDEM_TRUE){
				userProvidedJac->tpIndependent = DDEM_TRUE;
				for(int i=0; i < nVariables_; i++)
					for(int j=0; j < nParameters_; j++)
						userProvidedJac->pJac[i * nParameters_ + j] = 0.0;
			}
		}
		if(userProvidedJac->needed2nd){
			if(userProvidedJac->ttIndependent == DDEM_TRUE)
				for(int k=0; k < nVariables_; k++)
					userProvidedJac->ttJac[k] = 0.0;
			if(userProvidedJac->tpIndependent == DDEM_TRUE)
				for(int i=0; i < nVariables_; i++)
					for(int j=0; j < nParameters_; j++)
						userProvidedJac->tpJac[i * nParameters_ + j] = 0.0;
		}
	}else{
		if(DDEM_TRACE_PROBLEM)
			cout << "error in ddemHistory::evalHistorySegment" <<
				       "-invalid historySegmentIndex-" << endl;
		 return DDEM_ERR_PROB_INVALID_HISTORY_SEGMENT_INDEX;
	}
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::compT0(double* p,
           double& t0,
					void* Comm)
{
	userProvidedJac4T0_->reset();
	userProvidedJac4T0_->needed = DDEM_FALSE;
	userProvidedJac4T0_->needed2nd = DDEM_FALSE;
	return compT0Base(p,
           t0,
           userProvidedJac4T0_,
					Comm);
}
/************************************************************/
int ddemProblem::compT0Base(double* p,
           double& t0,
           ddemUserProvidedJac* userProvidedJac,
					void* Comm)
{
	if(t0Type_ == DDEM_SPECIFIED_BY_FUNC)
		t0Func_(nParameters_, p,
            t0,	userProvidedJac,
						Comm);
	else{
		t0 = t0Constant_;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
	if((userProvidedJac->needed)&&
			(userProvidedJac->pIndependent))
			for(int i=0; i < nParameters_; i++)
				userProvidedJac->pJac[i] = 0.0;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::compT0DiscDegree(double* p,
               int& t0DiscDegree,
							void* Comm)
{
	t0DiscDegree = t0DiscDegreeConstant_;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::compY0(double* p,
           double* y0,
					 double* historyStarts,
					 void* Comm)
{
	userProvidedJac4Y0_->reset();
	userProvidedJac4Y0_->needed = DDEM_FALSE;
	userProvidedJac4Y0_->needed2nd = DDEM_FALSE;
	return compY0Base(p,
           y0,
					 historyStarts,
           userProvidedJac4Y0_,
					 Comm);
}
/************************************************************/
int ddemProblem::compY0Base(double* p,
           double* y0,
					 double* historyStarts,
           ddemUserProvidedJac* userProvidedJac,
					 void* Comm)
{
	if(y0sType_ == DDEM_SPECIFIED_BY_FUNC)
		y0sFunc_(nParameters_, p,
            nVariables_, y0,
            userProvidedJac,
						Comm);
	else if (y0sType_ == DDEM_SPECIFIED_BY_CONSTANT){
		for(int i=0; i < nVariables_; i++)
			y0[i] = y0sConstant_[i];
		userProvidedJac->pIndependent = DDEM_TRUE;
	}else{//DDEM_SPECIFIED_BY_HISTORY
		double t0;
		if(userProvidedJac->needed == DDEM_FALSE){
			compT0(p, t0, Comm);
			evalHistorySegment(1, t0, p, y0, Comm);
		}else{
			userProvidedJac4T0_->reset();
			userProvidedJac4T0_->needed = DDEM_TRUE;
			userProvidedJac4T0_->needed2nd = DDEM_FALSE;
			compT0Base(p,
							t0,
							userProvidedJac4T0_,
							Comm);
			double* par_t0_par_p = userProvidedJac4T0_->pJac;	

			userProvidedJac4HistorySegment_->reset();
			userProvidedJac4HistorySegment_->needed = DDEM_TRUE;
			userProvidedJac4HistorySegment_->needed2nd = DDEM_FALSE;
			evalHistorySegmentBase(1, t0, p, y0, userProvidedJac4HistorySegment_, Comm);
			double* y0pL = userProvidedJac4HistorySegment_->tJac;
			/*------------------------------*/
			double* z0 = new double[nVariables_ * (nu_ + omega_)];
			compZ0(t0, y0, p, z0, historyStarts, Comm);
			double* y0pR = new double[nVariables_];
			evalF(t0, y0, z0, p, y0pR/*f*/, Comm);
			/*------------------------------*/
			for(int i=0; i < nVariables_; i++){
				double* par_y0_i_par_p_L = &userProvidedJac4HistorySegment_->pJac[i * nParameters_];
				double* par_y0_i_par_p_R = &userProvidedJac->pJac[i * nParameters_];
				for(int k=0; k < nParameters_; k++)
					par_y0_i_par_p_R[k] = par_y0_i_par_p_L[k] +
															(y0pL[i] - y0pR[i]) * par_t0_par_p[k];
			}
			delete y0pR;
			delete z0;
		}
	}
	if((userProvidedJac->needed)&&
		(userProvidedJac->pIndependent == DDEM_TRUE))
			for(int i=0; i < nVariables_; i++)
				for(int j=0; j < nParameters_; j++)
					userProvidedJac->pJac[i * nParameters_ + j] = 0.0;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::compZ0(double t0,double * y0,
											 double* p,
											 double* z0,
											 double* historyStarts,
											 void* Comm)
{
	double* alpha;
	int m = nVariables_;

	alpha = new double[nu_ + omega_];
	int* historyIndices;
	historyIndices = new int[nu_ + omega_];
	int retCode =
		evalDelayArguments(t0, y0, p, alpha, Comm);
	for(int i=0; i < nu_ + omega_ ; i++)
	{
		retCode = locateBetweenHistoryStarts(alpha[i], historyStarts, historyIndices[i]);
		if(retCode!= DDEM_SUCCESS)
			return retCode;
	}
	for(int k=0; k < nu_; k++){
		/*NEEDS*/
		retCode =
			evalHistorySegment(historyIndices[k], alpha[k], p, &z0[k * m], Comm);
		if(retCode!= DDEM_SUCCESS)
			return retCode;
	}
	for(int k=nu_; k < nu_ + omega_; k++){
		/*NEEDS*/
		retCode =
			evalDerivHistorySegment(historyIndices[k], alpha[k], p, &z0[k * m], Comm);
		if(retCode!= DDEM_SUCCESS)
			return retCode;
	}
	delete historyIndices;
	delete alpha;
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemProblem::locateBetweenHistoryStarts(double t,
																						double* historyStarts,
																						int& betweenHisroryIndex)
{
	int candidateIndex = 1;
	while(candidateIndex <= nHistorySegments_ - 1 ){
		if(historyStarts[candidateIndex - 1] <= t){
			betweenHisroryIndex = candidateIndex ;
			return DDEM_SUCCESS;
		}
		else
			candidateIndex += 1;
	}
	betweenHisroryIndex = nHistorySegments_;
	return DDEM_SUCCESS;
}
/************************************************************/
void ddemProblem::createUserProvidedJacs_()
{
	userProvidedJac4DelayArguments_ = new ddemUserProvidedJac;
	userProvidedJac4F_= new ddemUserProvidedJac;
	userProvidedJac4HistoryStart_ = new ddemUserProvidedJac;
	userProvidedJac4HistorySegment_ = new ddemUserProvidedJac;
	userProvidedJac4HistorySegment_->tJac = new double[nVariables_];
	userProvidedJac4HistorySegment_->pJac = new double[nVariables_ * nParameters_];
	userProvidedJac4T0_ = new ddemUserProvidedJac;
	userProvidedJac4T0_->pJac = new double[nParameters_];
	userProvidedJac4Y0_ = new ddemUserProvidedJac;
}
/************************************************************/
void ddemProblem::destroyUserProvidedJacs_()
{
	delete userProvidedJac4DelayArguments_;
	delete userProvidedJac4F_;
	delete userProvidedJac4HistoryStart_;
	delete userProvidedJac4HistorySegment_;
	delete userProvidedJac4T0_;
	delete userProvidedJac4Y0_;
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
